

#include "baseenv.h"
#ifdef THINKC5
#include <THINK.h>
#include <Windows.h>
#include <Menus.h>
#include <stdio.h>
#include <SegLoad.h>
#include <OSUtils.h>
#include <Memory.h>
#include <Events.h>
#include <Quickdraw.h>
#include <Sound.h>
#include <Resources.h>
#include <Fonts.h>
#include <Dialogs.h>
#include <Events.h>
#include <OSEvents.h>
#include <Desk.h>
#include <ToolUtils.h>
#include <PPCToolBox.h>
#include <Errors.h>
#include <GestaltEqu.h>
#include <ImageCompression.h>
#include <Movies.h>
#include <AppleEvents.h>
#include <LowMem.h>
#else
#ifdef WERKS
#include <Windows.h>
#include <Menus.h>
#include <stdio.h>
#include <SegLoad.h>
#include <OSUtils.h>
#include <Memory.h>
#include <Events.h>
#include <Quickdraw.h>
#include <Sound.h>
#include <Resources.h>
#include <Fonts.h>
#include <Dialogs.h>
#include <Events.h>
#include <Devices.h>
#include <ToolUtils.h>
#include <PPCToolBox.h>
#include <Errors.h>
#include <Gestalt.h>
#include <ImageCompression.h>
#include <Movies.h>
#include <AppleEvents.h>
#include <LowMem.h>
#else
#include <WindowMgr.h>
#include <MenuMgr.h>
#include <stdio.h>
#include <SegmentLdr.h>
#include <OSUtil.h>
#include <MemoryMgr.h>
#include <EventMgr.h>
#include <Color.h>
#include <SoundDvr.h>
#include <SoundMgr.h>
#include <ResourceMgr.h>
#endif
#endif

#include "tglobals.h"
#include "ecglobal.h"
#include "kglobals.h"
#include "sockmac.h"
#include "fkeys.h"


/* definition of CTIcon data (CTic resource) */
typedef struct _cti {
	short originX, originY; /* origin */
	short sizeX,sizeY,rowB; /* size of map & rowbytes */
	short spaceX, spaceY; /* spacing of icon (move after plot) */
	char theDat[]; /* baseAddr of bitmap will point to here */
} CTIcon;

struct EncodeHdr {
	unsigned int nIcons; /* number icons/characters */
	unsigned int nEncode; /* number encoding table entries used */
}; /* EncodeHdr */

struct EncodeItem {
	unsigned int sRangeE; /* starting encoded value for this chunk */
	                      /* of sequential characters */
	unsigned int sRangeI; /* starting index for this chunk */
	unsigned int nRange; /* number characters in this chunk */
}; /* EncodeItem */



/* ******************************************************************* */

typedef struct tagPALETTEENTRY
{
    unsigned char    peRed;
    unsigned char    peGreen;
    unsigned char    peBlue;
    unsigned char    peFlags;
} PALETTEENTRY;

/* Logical Palette */
typedef struct tagLOGPALETTE
{
    int    palVersion;
    int    palNumEntries;
    PALETTEENTRY palPalEntry[1];
} LOGPALETTE;

struct PictData {
	int picSize;		/* low word of picture size */
	Rect picFrame;		/* bounding box of picture */
	int versop;			/* version op 0x0011 */
	int vernum;			/* version number 0x02ff for version 2 */
	int headop;			/* header opcode  0x0c00 */
	int vers2a;			/* -2 for extended version 2 */
	int resv1;			/* reserved */
	char unkn[20];		/* depends on version */
};


struct PictPixMap {
	short rowBytes;		/* offset to next line */
	Rect bounds;		/* encloses bitmap */
	short pmVersion;	/* pixMap version number */
	short packType;		/* defines packing format */
	long packSize;		/* length of pixel data */
	Fixed hRes;			/* horiz. resolution (ppi) */
	Fixed vRes;			/* vert. resolution (ppi) */
	short pixelType;	/* defines pixel type */
	short pixelSize;	/* # bits in pixel */
	short cmpCount;		/* # components in pixel */
	short cmpSize;		/* # bits per component */
	long planeBytes;	/* offset to next plane */
	long resv1;			/* unknown */
	long resv2;			/* unknown */
	ColorTable cTable;	/* color table */
};

struct PictPixMap9A {
	long baseAddr;		/* 0xff 17-21 Inside Mac V6 */
	short rowBytes;		/* offset to next line */
	Rect bounds;		/* encloses bitmap */
	short pmVersion;	/* pixMap version number */
	short packType;		/* defines packing format */
	long packSize;		/* length of pixel data */
	Fixed hRes;			/* horiz. resolution (ppi) */
	Fixed vRes;			/* vert. resolution (ppi) */
	short pixelType;	/* defines pixel type */
	short pixelSize;	/* # bits in pixel */
	short cmpCount;		/* # components in pixel */
	short cmpSize;		/* # bits per component */
	long planeBytes;	/* offset to next plane */
	long resv1;			/* unknown */
	long resv2;			/* unknown */
	ColorTable cTable;	/* color table */
};



/* ******************************************************************* */

extern int colorOK; /* TRUE if have color QuickDraw */

